//Get NYT API ARTICLE TITLES/////////////////////////////////////////////////
void getTitles(){
    String request = baseURL + "?&api-key=" + apiKey;
  
    json = loadJSONObject(request);
    values = json.getJSONArray("results");
}

void drawTitles(){
  for(int i=0; i<values.size(); i++){
      processing.data.JSONObject articles = values.getJSONObject(i);
      String title = articles.getString("title");
      textSize(10);
      rotateX(radians(180));
      fill(0);
      text(title, width/2+vMargin, (hMargin+50)+i*15, 320-vMargin, height);
    }
}

//Get Twitter Trending Topics////////////////////////////////////////////////

void drawTwitters(ArrayList<String> tw) {
  Iterator<String> it = tw.iterator();
  int i = 0;
  while (it.hasNext ()) {
    String twitt = it.next();
    textSize(15);
    rotateX(radians(180));
    fill(0);
    text(twitt, vMargin, (hMargin+50)+i*15, width/2, height);
    i++;
  }
}

ArrayList<String> queryTwitter() {
  ArrayList<String> twitt = new ArrayList<String>();
  try {

    Trends trends = twitter.getPlaceTrends(trendId);
    for (int i = 0; i < 20; i++) {
      println(trends.getTrends()[i].getName());
      twitt.add(trends.getTrends()[i].getName());
    }

//    strTrend = "World Wide Trend Topic id: "+trendId;
  }
  catch (TwitterException te) {
    println("Couldn't connect: " + te);
  }

  return twitt;
}

///////////////////////////////////////////////new fx////////////////////////////////

//void drawTitles2(){
//  for(int i=0; i<values.size(); i++){
//      processing.data.JSONObject articles = values.getJSONObject(i);
//      String title = articles.getString("title");
//      textSize(10);
//      pushMatrix();
//      translate(LHandPos.x, LHandPos.y, LHandPos.z);
////      applyMatrix(LHandO);
//      fill(0);
//      float ellipseLH = map(LHandPos.z, 700, 2500, 50, 1);
//      text(title, 0,0,0);
//      popMatrix();
//      
//      translate(x, y, z);
//      rotateX(radians(180));
//      fill(0);      
//      text(title, 0, 0, width, height);
//    }
//}
//
//void drawTwitters2(ArrayList<String> tw) {
//  Iterator<String> it = tw.iterator();
//  int i = 0;
//  while (it.hasNext ()) {
//    String twitt = it.next();
//    textSize(15);
//    translate(x, y, z);
//    rotateX(radians(180));
//    fill(0);
//    text(twitt, 0, 0, width, height);
//    i++;
//  }
//}




