//import org.json.*;

import SimpleOpenNI.*; 

import twitter4j.conf.*;
//import twitter4j.api.*;
import twitter4j.*;

//import java.util.List;
import java.util.Iterator;

import ddf.minim.*;
 
Minim minim;
AudioPlayer song;



ConfigurationBuilder   cb;
Query query;
Twitter twitter;

ArrayList<String> twittersList;

int    trendId = 2450022; //worldWide

SimpleOpenNI  context;
PImage img, tweet, nyt;

int userID;
int[] userMap;

int closestX;
int closestY;
int hMargin = 25;
int vMargin = 20;

float lastX;
float lastY;

float magnitude;

float z, x, y;

PVector position;
PVector LHandPos;

///////Start TWITTER API Universal Variables/////////////////////////////////////////////////////////////////////

String apiKey = "676631ea298b4e8a9d84021b02947264";

String baseURL = "https://api.nytimes.com/svc/topstories/v1/home.json";

processing.data.JSONObject json;
processing.data.JSONArray values;

void setup(){
 
  size(640, 480, P3D); 
  
  minim = new Minim(this);
  song = minim.loadFile("tickTock.wav");
  
  song.play();
  song.loop();
 
  //initialize context variable
  context = new SimpleOpenNI(this);
 
  //asks OpenNI to initialize and start receiving depth sensor's data
  context.enableDepth(); 
 
  //asks OpenNI to initialize and start receiving User data
  context.enableUser(); 
 
  //enable mirroring - flips the sensor's data horizontally
  context.setMirror(true); 
 
  stroke(255, 0, 0);
  strokeWeight(5);
  textSize(20);
  
   
  img=createImage(640,480,RGB);
  img.loadPixels();
  
  tweet = loadImage("tLogo.png");
  nyt = loadImage("nytLogo.png");
  
  //Acreditacion
  cb = new ConfigurationBuilder();
  cb.setOAuthConsumerKey("YF6Kkzfno7XK3CU1tBu1x9NUJ");
  cb.setOAuthConsumerSecret("mykgVcy7wXSYlCWz7Vun5N590pZCT6VW5vSrmc0GpaSto75ZxV");
  cb.setOAuthAccessToken("728359199806103552-qlgdgCfxuUebIJ1PDBDiaty9XdvGfMj");
  cb.setOAuthAccessTokenSecret("8t48kng29iIqatug7ZEebGto675eS7erlFaOJFKrq3cJ6");

  //Make the twitter object and prepare the query
  twitter = new TwitterFactory(cb.build()).getInstance();

  //SEARCH
  twittersList = queryTwitter();
  
  getTitles();
  
///////////////////////////random numbers/////////////////////////////////////////

//Z axis
z = random(1,50);
//x axis
x = random(0, width);
//y axis
y = random(0, height);

println("x: " + x + " y: " + y + " z: " + z);
  
}
 
void draw(){
  context.update();
  background(100);
  
//////BEGIN DRAWING ENVIRONMENT////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   noStroke();
   fill(225, 232, 237);
   rect(0, 0, width/2, height);
   fill(255);
   rect(width/2, 0, width, height);
   
   image(tweet, vMargin, hMargin, 50, 50);
   image(nyt, width/2 + vMargin, hMargin, 40, 40);
   
   
   
   
/////CHANGE COORDINATE SYSTEM////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
  
//  translate(width/2, height/2, 0);
  rotateX(radians(180));
   

//////BEGIN USER INTERACTION////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  // if we have detected any users
  if (context.getNumberOfUsers() > 0) { 
    // find out which pixels have users in them
    userMap = context.userMap();
    // populate the pixels array
    // from the sketch's current contents
    loadPixels(); 
  for (int i = 0; i < userMap.length; i++) { 
    // if the current pixel is on a user
    if (userMap[i] != 0) {
    // make it green
//    pixels[i] = color(255, 255, 255, 0); 
    }
  }
  // display the changed pixel array
  updatePixels(); 
 }
 
  //draw significant points of users
 
  //get array of IDs of all users present 
  int[] users=context.getUsers();
 
  ellipseMode(CENTER);
 
  //iterate through users
  for(int i=0; i < users.length; i++){
    
    int uid=users[i];
    
    //check if user has a skeleton
    if(context.isTrackingSkeleton(uid)){
      
////////DRAW HEAD ORIENTATION///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
      
      //draw head
      position = new PVector();
      context.getJointPositionSkeleton(uid, SimpleOpenNI.SKEL_TORSO, position);
      PMatrix3D orientation = new PMatrix3D();
      float confidence = context.getJointOrientationSkeleton(uid, SimpleOpenNI.SKEL_TORSO, orientation);
//      println("c: " + confidence);
      
////////LEFT SIDE///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
 
      //draw left hand
      LHandPos=new PVector();
      context.getJointPositionSkeleton(uid,SimpleOpenNI.SKEL_LEFT_HAND, LHandPos);
      PMatrix3D orientationL = new PMatrix3D();
      float lHandCon = context.getJointOrientationSkeleton(uid, SimpleOpenNI.SKEL_LEFT_HAND, orientation);
      
      
////////RIGHT SIDE////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  

      //draw right hand 
      PVector realRHand = new PVector();
      context.getJointPositionSkeleton(uid, SimpleOpenNI.SKEL_RIGHT_HAND, realRHand);
      PMatrix3D orientationR = new PMatrix3D();
      float rHandCon = context.getJointOrientationSkeleton(uid, SimpleOpenNI.SKEL_RIGHT_HAND, orientation);


//////Begin Calculating distance between Left and Right Hand////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      //calculate difference by subtracting one vector from another
      PVector differenceVector = PVector.sub(LHandPos, realRHand);
      
      //calculate distance and direction of difference vector
      magnitude = differenceVector.mag();
      differenceVector.normalize();
      
      //draw line between two hands
      context.drawLimb(uid, SimpleOpenNI.SKEL_LEFT_HAND, SimpleOpenNI.SKEL_RIGHT_HAND);
      
      //display
      pushMatrix();
        fill(abs(differenceVector.x) * 255, abs(differenceVector.y) * 255, 
               abs(differenceVector.z) * 255);
      popMatrix();
      
//      println("m: " + magnitude);
      
///////TRANSLATION OF TORSO ORIENTATION///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
      
//      println("x: " + position.x + " y: " + position.y + " z: " + position.z);

///////BEGIN IF STATEMENTS FOR USER MOVEMENT////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      
      if(position.x > 20){
        //NYT text
        drawTitles();
        
        
      } else if(position.x < -10){
        //Twitter text
        drawTwitters(twittersList);
        
      }
      
      if(magnitude > 1000){
       
        drawTitles();
        drawTwitters(twittersList);
      
      }
      
//      if(magnitude < 300){
//        drawTitles2();
////        drawTwitters2(twittersList);
//        
//      }
      
      
      
    }
  }
  saveFrame("frames2/####.png");
}
 
//is called everytime a new user appears
void onNewUser(SimpleOpenNI curContext, int userId){
  println("onNewUser - userId: " + userId);
  //asks OpenNI to start tracking a skeleton data for this user 
  //NOTE: you cannot request more than 2 skeletons at the same time due to the perfomance limitation
  //      so some user logic is necessary (e.g. only the closest user will have a skeleton)
  curContext.startTrackingSkeleton(userId);
}
 
//is called everytime a user disappears
void onLostUser(SimpleOpenNI curContext, int userId){
  println("onLostUser - userId: " + userId);
 
}
